// -----------------------------------------------------------
// IReceivingListener.java
// -----------------------------------------------------------

package cz.vutbr.wsagent.comm;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * This interface should be used when a message is received.
 * @author Martin Gábor
 */
public interface IReceivingListener extends ActionListener{

    /**
     * This is called when some message has been received. Deciding what to do with a message
     * should be implemented here.
     * @param event Event defining what message result has come.
     */
    public void actionPerformed(ActionEvent event);
}
