// -----------------------------------------------------------
// ISendListener.java
// -----------------------------------------------------------

package cz.vutbr.wsagent.comm;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * The interface for sending messages. This method should be called after a message has been
 * sent. It should wait until message is transmitted.
 * The length of waiting should be defined by a time interval.
 * @author Martin Gábor
 */
public interface ISendListener extends ActionListener{

    /**
     * This is called when sending successful.
     * @param arg0 Event describing the result of sending.
     */
    public void actionPerformed(ActionEvent arg0);

}
