/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.vutbr.wsagent.comm;

/**
 *
 * @author Marek Houšť
 */
public class RadioClassRefreshAck extends net.tinyos.message.Message {

    /** The default size of this message type in bytes. */
    public static final int DEFAULT_MESSAGE_SIZE = 28;

    /** The Active Message type associated with this message. */
    public static final int AM_TYPE = 12;


    /** Create a new RadioClass of size 28. */
    public RadioClassRefreshAck() {
        super(DEFAULT_MESSAGE_SIZE);
        amTypeSet(AM_TYPE);
    }

    /** Create a new RadioClass of the given data_length. */
    public RadioClassRefreshAck(int data_length) {
        super(data_length);
        amTypeSet(AM_TYPE);
    }

    /**
     * Create a new RadioClass with the given data_length
     * and base offset.
     */
    public RadioClassRefreshAck(int data_length, int base_offset) {
        super(data_length, base_offset);
        amTypeSet(AM_TYPE);
    }

    /**
     * Create a new RadioClass using the given byte array
     * as backing store.
     */
    public RadioClassRefreshAck(byte[] data) {
        super(data);
        amTypeSet(AM_TYPE);
    }

    /**
     * Create a new RadioClass using the given byte array
     * as backing store, with the given base offset.
     */
    public RadioClassRefreshAck(byte[] data, int base_offset) {
        super(data, base_offset);
        amTypeSet(AM_TYPE);
    }

    /**
     * Create a new RadioClass using the given byte array
     * as backing store, with the given base offset and data length.
     */
    public RadioClassRefreshAck(byte[] data, int base_offset, int data_length) {
        super(data, base_offset, data_length);
        amTypeSet(AM_TYPE);
    }

    /**
     * Create a new RadioClass embedded in the given message
     * at the given base offset.
     */
    public RadioClassRefreshAck(net.tinyos.message.Message msg, int base_offset) {
        super(msg, base_offset, DEFAULT_MESSAGE_SIZE);
        amTypeSet(AM_TYPE);
    }

    /**
     * Create a new RadioClass embedded in the given message
     * at the given base offset and length.
     */
    public RadioClassRefreshAck(net.tinyos.message.Message msg, int base_offset, int data_length) {
        super(msg, base_offset, data_length);
        amTypeSet(AM_TYPE);
    }

    /**
    /* Return a String representation of this message. Includes the
     * message type name and the non-indexed field values.
     */
    public String toString() {
      String s = "Message <RadioClass> \n";
      try {
        s += "  [msg=";
        for (int i = 0; i < 28; i++) {
          s += "0x"+Long.toHexString(getElement_msg(i) & 0xff)+" ";
        }
        s += "]\n";
      } catch (ArrayIndexOutOfBoundsException aioobe) { /* Skip field */ }
      return s;
    }

    // Message-type-specific access methods appear below.

    /////////////////////////////////////////////////////////
    // Accessor methods for field: msg
    //   Field type: short[], unsigned
    //   Offset (bits): 0
    //   Size of each element (bits): 8
    /////////////////////////////////////////////////////////

    /**
     * Return whether the field 'msg' is signed (false).
     */
    public static boolean isSigned_msg() {
        return false;
    }

    /**
     * Return whether the field 'msg' is an array (true).
     */
    public static boolean isArray_msg() {
        return true;
    }

    /**
     * Return the offset (in bytes) of the field 'msg'
     */
    public static int offset_msg(int index1) {
        int offset = 0;
        if (index1 < 0 || index1 >= 28) throw new ArrayIndexOutOfBoundsException();
        offset += 0 + index1 * 8;
        return (offset / 8);
    }

    /**
     * Return the offset (in bits) of the field 'msg'
     */
    public static int offsetBits_msg(int index1) {
        int offset = 0;
        if (index1 < 0 || index1 >= 28) throw new ArrayIndexOutOfBoundsException();
        offset += 0 + index1 * 8;
        return offset;
    }

    /**
     * Return the entire array 'msg' as a short[]
     */
    public short[] get_msg() {
        short[] tmp = new short[28];
        for (int index0 = 0; index0 < numElements_msg(0); index0++) {
            tmp[index0] = getElement_msg(index0);
        }
        return tmp;
    }

    /**
     * Set the contents of the array 'msg' from the given short[]
     */
    public void set_msg(short[] value) {
        for (int index0 = 0; index0 < value.length; index0++) {
            setElement_msg(index0, value[index0]);
        }
    }

    /**
     * Return an element (as a short) of the array 'msg'
     */
    public short getElement_msg(int index1) {
        return (short)getUIntBEElement(offsetBits_msg(index1), 8);
    }

    /**
     * Set an element of the array 'msg'
     */
    public void setElement_msg(int index1, short value) {
        setUIntBEElement(offsetBits_msg(index1), 8, value);
    }

    /**
     * Return the total size, in bytes, of the array 'msg'
     */
    public static int totalSize_msg() {
        return (224 / 8);
    }

    /**
     * Return the total size, in bits, of the array 'msg'
     */
    public static int totalSizeBits_msg() {
        return 224;
    }

    /**
     * Return the size, in bytes, of each element of the array 'msg'
     */
    public static int elementSize_msg() {
        return (8 / 8);
    }

    /**
     * Return the size, in bits, of each element of the array 'msg'
     */
    public static int elementSizeBits_msg() {
        return 8;
    }

    /**
     * Return the number of dimensions in the array 'msg'
     */
    public static int numDimensions_msg() {
        return 1;
    }

    /**
     * Return the number of elements in the array 'msg'
     */
    public static int numElements_msg() {
        return 28;
    }

    /**
     * Return the number of elements in the array 'msg'
     * for the given dimension.
     */
    public static int numElements_msg(int dimension) {
      int array_dims[] = { 28,  };
        if (dimension < 0 || dimension >= 1) throw new ArrayIndexOutOfBoundsException();
        if (array_dims[dimension] == 0) throw new IllegalArgumentException("Array dimension "+dimension+" has unknown size");
        return array_dims[dimension];
    }

    /**
     * Fill in the array 'msg' with a String
     */
    public void setString_msg(String s) {
         int len = s.length();
         int i;
         for (i = 0; i < len; i++) {
             setElement_msg(i, (short)s.charAt(i));
         }
         setElement_msg(i, (short)0); //null terminate
    }

    /**
     * Read the array 'msg' as a String
     */
    public String getString_msg() {
         char carr[] = new char[Math.min(net.tinyos.message.Message.MAX_CONVERTED_STRING_LENGTH,28)];
         int i;
         for (i = 0; i < carr.length; i++) {
             if ((char)getElement_msg(i) == (char)0) break;
             carr[i] = (char)getElement_msg(i);
         }
         return new String(carr,0,i);
    }

}
