// -----------------------------------------------------------
// Agent.java
// -----------------------------------------------------------

package cz.vutbr.wsagent.entity;

/**
 * This class fully describes agent.
 * Each property defines agent's behaviour.
 * Id property is used to determine concrete agent. It is used mostly for database
 * purposes.
 *
 * @author Martin Gábor
 */
public class Agent {

    private long id;
    private long agentId;
    private long classId;
    private String name = "";
    private String description = "";
    private String planBase = "";
    private String plan = "";
    private String beliefBase = "";
    private String inputBase = "";

    /**
     * Get the value of id
     *
     * @return the value of id
     */
    public long getId() {
        return id;
    }

    /**
     * Set the value of id
     *
     * @param id new value of id
     */
    public void setId(long id) {
        this.id = id;
    }

    /**
     * Get the value of agent id
     *
     * @return the value of id
     */
    public long getAgentId() {
        return agentId;
    }

    /**
     * Set the value of agent id
     *
     * @param id new value of id
     */
    public void setAgentId(long id) {
        this.agentId = id;
    }


    /**
     * Get the value of agent class id
     *
     * @return the value of id
     */
    public long getClassId() {
        return classId;
    }

    /**
     * Set the value of id
     *
     * @param id new value of id
     */
    public void setClassId(long id) {
        this.classId = id;
    }

    /**
     * Get the value of name
     *
     * @return the value of name
     */
    public String getName() {
        return name;
    }

    /**
     * Set the value of name
     *
     * @param name new value of name
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Get the value of description
     *
     * @return the value of description
     */
    public String getDescription() {
        return description;
    }

    /**
     * Set the value of description
     *
     * @param description new value of description
     */
    public void setDescription(String description) {
        this.description = description;
    }


    /**
     * Get the value of beliefBase
     *
     * @return the value of beliefBase
     */
    public String getBeliefBase() {
        return beliefBase;
    }

    /**
     * Set the value of beliefBase
     *
     * @param beliefBase new value of beliefBase
     */
    public void setBeliefBase(String beliefBase) {
        this.beliefBase = beliefBase;
    }

    /**
     * Get the value of inputBase
     *
     * @return the value of inputBase
     */
    public String getInputBase() {
        return inputBase;
    }

    /**
     * Set the value of inputBase
     *
     * @param inputBase new value of inputBase
     */
    public void setInputBase(String inputBase) {
        this.inputBase = inputBase;
    }

    /**
     * Get the value of plan
     *
     * @return the value of plan
     */
    public String getPlan() {
        return plan;
    }

    /**
     * Set the value of plan
     *
     * @param plan new value of plan
     */
    public void setPlan(String plan) {
        this.plan = plan;
    }

    /**
     * Get the value of planBase
     *
     * @return the value of planBase
     */
    public String getPlanBase() {
        return planBase;
    }

    /**
     * Set the value of planBase
     *
     * @param planBase new value of planBase
     */
    public void setPlanBase(String planBase) {
        this.planBase = planBase;
    }


}
